#include <stdio.h>
#include <ctype.h>
#include "tinycrc.h"

/*
    CRC32
*/

uint32_t tinycrc_crc32(const uint8_t* data, uint16_t size)
{

    const unsigned long crc_table[16] = {
        0x00000000, 0x1db71064, 0x3b6e20c8, 0x26d930ac,
        0x76dc4190, 0x6b6b51f4, 0x4db26158, 0x5005713c,
        0xedb88320, 0xf00f9344, 0xd6d6a3e8, 0xcb61b38c,
        0x9b64c2b0, 0x86d3d2d4, 0xa00ae278, 0xbdbdf21c
    };

    if (data == nullptr) {
        return 0;
    }

    unsigned long crc = ~0L;

    for (int index = 0 ; index < size ; ++index) {
        crc = crc_table[(crc ^ data[index]) & 0x0f] ^ (crc >> 4);
        crc = crc_table[(crc ^ (data[index] >> 4)) & 0x0f] ^ (crc >> 4);
        crc = ~crc;
    }

    return crc & 0xFFFFFFFF;

};
